package com.uea.stemmer;

import java.io.*;
import com.uea.stemmer.UEALite;

/**
 * <p>Title: Command line program to run words from the Wall Street Journal through UEALite</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Richard Churchill
 * @version 1.0
 */
public class WSJTest {
    public WSJTest() {}

    public static void main(String[] args) throws Exception {

        System.out.println( "About to load bag of words, press any key to continue" );
        System.in.read();

        File inputFile = new File( "wsj_marked_1.txt");
        BufferedReader reader = new BufferedReader(new FileReader(inputFile));

        File outputFile = new File( "wsj_java_test.xls");
        Writer output = null;

        //use buffering
        output = new BufferedWriter(new FileWriter(outputFile));
        output.write( "Original Word\tPerl Result\tJava Result\tPerl Rule\tJava Rule\tState\n" );


        // set max word length and acronym length in constructor if required, defaults are provided
        UEALite stemmer = new UEALite( 100, 200 );
        System.out.println( "Max word length: " + stemmer.getMaxWordLength() );
        System.out.println( "Max acc length: " + stemmer.getMaxAcronymLength() );

        int count = 0;
        int errorCount = 0;
        try {
            for (String line = reader.readLine(); line != null; line = reader.readLine()) {
                String [] temp = null;
                boolean result = false;


                temp = line.split( "\t" );
                Word stemmed_word = stemmer.stem( temp[ 1 ] );
                if(temp[2].equals( stemmed_word.word ) ) result = true; else errorCount++;

                output.write( temp[ 1 ] + "\t" + temp[ 2 ] + "\t" + stemmed_word.word + "\t" + temp[ 3 ] + "\t" + stemmed_word.ruleno + "\t" + result + "\n" );

                count++;
            }
        } finally {
            reader.close();
        }
        double errorPercent = errorCount / count;

        System.out.println( "Errors: " + errorCount );
        output.write( "Errors: " + errorCount + "\n" );
        output.write( "Total: " + count + "\n" );

        if (output != null) output.close();

    }

}
